{Ŀ
  pp p  ᮥ  EMSI     
  ᯥ稢 HandShacking, p 䠩          
  Name2Transmit  砥  p Hold          
  䠩 (Zmodem).                                   
     맮:                                         
       EMSI                                         
                                                    
  !! C CH        
     C CC  CC  !!   
                                                    
  p C.. 1992-1994 . 2:5020/67.0fidonet.org
 }

Uses
  Dos,Crt, ApMisc, ApPort, ApUart, OoCom, OoAbsPcl, OoZmodem,OOModem,OoArchiv;

Type
  HexString = String[4];

Const
  Name2Transmit        = 'EMSI.PAS';
  DialNumber           : string = '13';
  MaxTries             = 10;                { Maximum of tries }
  FingerPrint          = '{EMSI}';
  System_Address       = '2:5020/67.200';   { Your address }
  Password             = 'SERGIC';          { Session password }
  Link_Codes           = '{8N1}';           { Modem setup }
  Compatibility_Codes  = '{ZMO}';           { Z-Modem 1024k}
  Mailer_Product_Code  = '{00}';
  Mailer_Name          = 'ZelMailer';
  Mailer_Version       = '1';
  Mailer_Serial_Number = '{02}';
  BBSName              = '{IDENT}{[ZelAK][Zelenograd][Sergic Dobridnuk :-)][-Unpublished-][9600][MO,XA,ZYX]}';

  EMSI_INQ : String = '**EMSI_INQC816'+#13;
  EMSI_REQ : String = '**EMSI_REQA77E'+#13;
  EMSI_ACK : String = '**EMSI_ACKA490'+#13;
  EMSI_NAK : String = '**EMSI_NAKEEC3'+#13;

type
  TonePulseType = (Default, Tone, Pulse);
  NumberStr = String[20];
  PrefixStr = String[MaxDialStr];
  ModemPtr=^ SimpComModem;
  SimpComModem =
    object(HayesModem)
      DialingMode : TonePulseType;
      constructor Init(Port : AbstractPortPtr);
      procedure SetDialingMode(ToneOrPulse : TonePulseType);
      function GetDialingMode : TonePulseType;
    end;

Var
  EMSI_DAT : String;            { NOTE : EMSI_DAT has no maximum length ! <255 chars }
  Length_EMSI_DAT : HexString;  { Expressed in Hexidecimal }

  Packet,Tempo : string;
  Rec_EMSI_DAT : String;        { EMSI_DAT sent by the answering system }
  Len_Rec_EMSI_DAT : Word;

  Len,
  CRC : HexString;

  C : Char;
  Loop,ComP,TimeOut,Tries : integer;
  Temp : String;

  ComPort : UartPortPtr;

  Protocol : ZmodemProtocolPtr;   {the Zmodem object used by our program}
  Modem : ModemPtr;               {the Hayes-modem object used by our program}
  FML : FileMaskListPtr;

{****  String functions ****}

Function Up_Case(St : String) : String;
Begin
  For Loop := 1 to Length(St) do
    St[Loop] := Upcase(St[Loop]);

  Up_Case := St;
End;

{****  Mathematical Functions ****}

function Hex(i : Word) : HexString;
const
  hc : array[0..15] of Char = '0123456789ABCDEF';
var
  l, h : Byte;
begin
  l := Lo(i);
  h := Hi(i);
  Hex[0] := #4;          { Length of String = 4 }
  Hex[1] := hc[h shr 4];
  Hex[2] := hc[h and $F];
  Hex[3] := hc[l shr 4];
  Hex[4] := hc[l and $F];
end {Hex} ;

Function Power(Base,E : Byte) : Longint;
Begin
  Power := Round(Exp(E * Ln(Base) ));
End;

Function Hex2Dec(HexStr : String) : Longint;

{ Maximum hexidecimal number that can be handled is about 'FFFFFF' }
{ Do not start the hexidecimal number with a dollar sign '$'       }

Var
  I,HexBit : Byte;
  Temp : Longint;
  Code : integer;

Begin
  Temp := 0;
  For I := Length(HexStr) downto 1 do
  Begin
    If HexStr[I] in ['A','a','B','b','C','c','D','d','E','e','F','f'] then
      Val('$' + HexStr[I],HexBit,Code)
        else
          Val(HexStr[I],HexBit,Code);
    Temp := Temp + HexBit * Power(16,Length(HexStr) - I);
  End;
  Hex2Dec := Temp;
End;

Function Bin2Dec(BinStr : String) : Longint;

{ Maximum is 16 bits, though a requirement for more would be   }
{ easy to accomodate.  Leading zeroes are not required. There  }
{ is no error handling - any non-'1's are taken as being zero. }

Var
  I : Byte;
  Temp : Longint;
  BinArray : Array[0..15] of char;

Begin
  For I := 0 to 15 do
    BinArray[I] := '0';

  For I := 0 to Pred(Length(BinStr)) do
    BinArray[I] := BinStr[Length(BinStr) - I];

  Temp := 0;

  For I := 0 to 15 do
    If BinArray[I] = '1' then inc(Temp,Round(Exp(I * Ln(2))));

  Bin2Dec := Temp;
End;

function CRC16(s:string):word;  { By Kevin Cooney }
var
  crc : longint;
  t,r : byte;
begin
  crc:=0;
  for t:=1 to length(s) do
  begin
    crc:=(crc xor (ord(s[t]) shl 8));
    for r:=1 to 8 do
      if (crc and $8000)>0 then
        crc:=((crc shl 1) xor $1021)
          else
            crc:=(crc shl 1);
  end;
  CRC16:=(crc and $FFFF);
end;

procedure Abort(Msg : String; Code : Word);
begin
  WriteLn(Msg, ': ', Code);
  Halt;
end;

{$F+}
function KbdAbort : Boolean;
var
  C : Char;
begin
  KbdAbort := False;
  if KeyPressed then begin
    C := ReadKey;
    if C = #0 then C := ReadKey;
    if C = #$1B then KbdAbort := True;
  end;
end;
{$F-}

{$F+}
procedure ProtocolStatus(AP : AbstractProtocolPtr; Starting, Ending : Boolean);
begin
  if Starting then
    WriteLn(ProtocolTypeString[AP^.GetProtocol], ' started');

  Write('Bytes transferred: ', AP^.GetBytesTransferred,
          '   Bytes remaining: ', AP^.GetBytesRemaining,#13);

  if Ending then
    WriteLn(ProtocolTypeString[AP^.GetProtocol], ' ended');
end;
{$F-}

{$F+}
procedure ProtocolLogging(AP : AbstractProtocolPtr; LogFileStatus : LogFileType);
var
  FLog : Text;
begin
  Assign(FLog, 'EXAMPLE.HIS');
  Append(FLog);
  if IOResult = 2 then
    ReWrite(FLog);
  if IOResult <> 0 then
    Exit;
  case LogFileStatus of
    lfReceiveStart : WriteLn(FLog, AP^.GetFilename, ' receive start');
    lfReceiveOk    : WriteLn(FLog, AP^.GetFilename, ' receive ok');
    lfReceiveFail  : WriteLn(FLog, AP^.GetFilename, ' receive failed');
    lfReceiveSkip  : WriteLn(FLog, AP^.GetFilename, ' receive skipped');
    lfTransmitStart: WriteLn(FLog, AP^.GetFilename, ' transmit start');
    lfTransmitOk   : WriteLn(FLog, AP^.GetFilename, ' transmit ok');
    lfTransmitFail : WriteLn(FLog, AP^.GetFilename, ' transmit failed');
    lfTransmitSkip : WriteLn(FLog, AP^.GetFilename, ' transmit skipped');
  end;
  Close(FLog);
  if IOResult <> 0 then ;
end;
{$F-}

{$F+}
function ProtocolAccept(AP : AbstractProtocolPtr) : Boolean;
var
  S : String[12];
  DotPos : Byte;
begin
  ProtocolAccept := True;
  S := AP^.GetFilename;
  DotPos := Pos('.', S);
  if DotPos <> 0 then begin
    S := Copy(S, DotPos+1, Length(S));
    if S = 'ARC' then
      ProtocolAccept := False;
  end;
end;
{$F-}
{$F+}
function NextFileMaskList(AP : AbstractProtocolPtr;
                          var FName : PathStr) : Boolean;
  {-Custom function to compare all files in dir against list of masks}
const
  AnyFileButDir = AnyFile and not Directory;
var
  Finished : Boolean;
begin
  AsyncStatus := 0;
  FName := '';
  NextFileMaskList := False;
  Finished := False;

  {Loop through all files until we find one that meets a mask}
  repeat
    if AP^.FindingFirst then begin
      FindFirst('*.*', AnyFileButDir, AP^.CurRec);
      AP^.FindingFirst := False;
    end else
      FindNext(AP^.CurRec);

    {Check for errors}
    if DosError <> 0 then begin
      {Failed to find file, return error status}
      case DosError of
        3  : AP^.APort^.GotError(epFatal+ecDirNotFound);
        18 : Finished := True;
      end;
    end else if FML^.Match(AP^.CurRec.Name) then begin
      FName := AP^.CurRec.Name;
      NextFileMaskList := True;
      Exit;
    end;
  until Finished;
end;
{$F-}

constructor SimpComModem.Init(Port : AbstractPortPtr);
  begin
    if not HayesModem.Init(Port) then
      Fail;
    DialingMode := Default;
  end;

  procedure SimpComModem.SetDialingMode(ToneOrPulse : TonePulseType);
  begin
    case ToneOrPulse of
      Tone :
        begin
          SetDialTone;
          DialingMode := Tone;
        end;
      Pulse :
        begin
          SetDialPulse;
          DialingMode := Pulse;
        end;
    end;
  end;

  function SimpComModem.GetDialingMode : TonePulseType;
  begin
    GetDialingMode := DialingMode;
  end;

Procedure RaiseDTR;
Begin
 {}
End;

Procedure LowerDTR;
Begin
{}
End;

Procedure Purge_Input;
Begin
{}
End;

Procedure Hangup;
Begin
    Modem^.HangupModem(0, True);
End;

{**** EMSI Handshake Routines ****}

Procedure Create_EMSI_DAT;
Begin
  FillChar(EMSI_DAT,255,' ');

  EMSI_DAT := FingerPrint + '{' + System_Address + '}{'+ Password + '}' +
              Link_Codes + Compatibility_Codes + Mailer_Product_Code +
              '{' + Mailer_Name + '}{' + Mailer_Version + '}' +
              Mailer_Serial_Number+BBSName;

  Length_EMSI_DAT := Hex(Length(EMSI_DAT));
End;

Function Get_EMSI_REQ : Boolean;
Begin
  Temp := '';
  ComPort^.GetStringTimeout(Temp,255,[#10,#13],200);
  If Up_Case(Temp) = EMSI_REQ then
    get_EMSI_REQ := TRUE
      else
        get_EMSI_REQ := FALSE;
End;

Procedure Send_EMSI_DAT;
Begin
  CRC := Hex(CRC16('EMSI_DAT' + Length_EMSI_DAT + EMSI_DAT));
  ComPort^.PutStringTimeOut('**EMSI_DAT' + Length_EMSI_DAT + EMSI_DAT + CRC,1000);
End;

Function Get_EMSI_ACK : Boolean;
Begin
  Temp := '';
  ComPort^.GetStringTimeout(Temp,255,[#10,#13],100);
  If Up_Case(Temp) = EMSI_ACK then
    get_EMSI_ACK := TRUE
      else
        get_EMSI_ACK := FALSE;
End;

Function Get_EMSI_NAK : Boolean;
Begin
  Temp := '';
  ComPort^.GetStringTimeout(Temp,255,[#10,#13],100);
  If Up_Case(Temp) = EMSI_NAK then
    get_EMSI_NAK := TRUE
      else
        get_EMSI_NAK := FALSE;
End;

Procedure Get_EMSI_DAT;
Label Rep;
var InPacket:integer;

Begin
  Rep:
  Temp := '';
  For Loop := 1 to 10 do                  { Read in '**EMSI_DAT' }
    begin
    ComPort^.GetCharTimeOut(C,100);
    Temp := Temp + C;
    end;
  Delete(Temp,1,2);                       { Remove the '**'      }

  Len := '';
  For Loop := 1 to 4 do                   { Read in the length   }
    begin
    ComPort^.GetCharTimeOut(C,100);
    Len := Len + C;
    end;
  Temp := Temp + Len;

  Len_Rec_EMSI_DAT := Hex2Dec(Len);

  if Temp='EMSI_ACKA490' then
       begin
       while C<>#13 do ComPort^.GetCharTimeOut(C,100);
       Goto Rep;
       end;

  Packet:='';
  For Loop := 1 to Len_Rec_EMSI_DAT do    { Read in the packet   }
    begin
    ComPort^.GetCharTimeOut(C,500);
    {Packet := Packet + C;}
    end;

  Temp := Temp + Packet;

  CRC := '';
  For Loop := 1 to 4 do                   { Read in the CRC      }
    begin
    ComPort^.GetCharTimeOut(C,100);
    CRC := CRC + C;
    end;
  Rec_EMSI_DAT := Packet;

  Writeln('Rec_EMSI_DAT = ',Rec_EMSI_DAT);

  If Hex(CRC16(Temp)) <> CRC then
    Writeln('The recieved EMSI_DAT is corrupt!!!!');
End;


Begin
  { Assumes connection has been made at this point }
  Create_EMSI_Dat;
  if ParamStr(1)<>'' then DialNumber:=ParamStr(1);
  if ParamStr(2)<>'' then
     begin
     if ParamStr(2) = 'COM2' then
       New(ComPort, InitCustom(Com2, 9600, NoParity, 8, 1, 2048, 2048, DefPortOptions))
     else
       New(ComPort, InitCustom(Com1, 9600, NoParity, 8, 1, 2048, 2048, DefPortOptions));
     end
   else
       New(ComPort, InitCustom(Com2, 9600, NoParity, 8, 1, 2048, 2048, DefPortOptions));
  { Port initialization }

  if ComPort = nil then
    Abort('?? Failed to open port', AsyncStatus);
  WriteLn('After initPort :',StatusStr(AsyncStatus));

  { Modem initialization }
  New(Modem,Init(ComPort));
  if Modem=nil then
      Abort('Failed to instantiate modem object',AsyncStatus);
  WriteLn('After initModem :',StatusStr(AsyncStatus));

  Tries := 0;
  repeat
  { Modem resetting }
  Modem^.ResetModem;
  WriteLn('After ResetModem :',StatusStr(AsyncStatus));

  { Calling number }
  Modem^.DialModem(DialNumber);
  WriteLn('After Dialing :',StatusStr(AsyncStatus));
  if (AsyncStatus mod 10000)=ecBUSY then Writeln('REdialing');
  Tries:=Tries+1;
  until not( ((AsyncStatus mod 10000)=ecBUSY)
        or ((AsyncStatus mod 10000)=ecNOCARRIER) )
        or (Tries=MaxTries);

  Tries := 0;
  Repeat
    ComPort^.PutStringTimeOut(EMSI_INQ,1000);
    Inc(Tries);
  Until (Get_EMSI_REQ = TRUE) or (Tries = MaxTries);

  If Tries = MaxTries then
    Abort('?? Host system failed to acknowledge the inquiry sequence', AsyncStatus);

  { Used for debugging }
  Writeln('Boss has acknowledged receipt of EMSI_INQ');

  Tries := 0;
  repeat
  Inc(Tries);
  Until (Get_EMSI_NAK = TRUE) or (Tries = MaxTries);

  Writeln('Sending EMSI_DAT');
  Send_EMSI_DAT;

  Tries := 0;
  Repeat
    Inc(Tries);
  Until (Get_EMSI_ACK = True) or (Tries = MaxTries);

  If Tries = MaxTries then
    Abort('Host system failed to acknowledge the EMSI_DAT packet'+ StatusStr(AsyncStatus),(AsyncStatus));

  Writeln('Boss has acknowledged receipt of EMSI_DAT');

  Get_EMSI_DAT;
  ComPort^.PutStringTimeOut(EMSI_ACK,500);

  { TRANSMITING }

  New(Protocol, Init(ComPort));
  if Protocol = nil then
    Abort('Failed to initialize protocol', AsyncStatus);

  {Set abort and status procedures}
  ComPort^.SetAbortFunc(KbdAbort);
  Protocol^.SetShowStatusProc(ProtocolStatus);

  {Make a FileMaskList object}
  New(FML, Init);
  if FML = nil then
    Abort('Failed to initialize file mask', AsyncStatus);

  {Add a couple of file masks}
  if not FML^.Append(Name2Transmit) then;

  {Set our next-file function}
  Protocol^.SetNextFileFunc(NextFileMaskList);

  {Transmit all matching files}
  Protocol^.ProtocolTransmit;
  if AsyncStatus = ecOk then
    WriteLn('Transfer complete OK')
  else
    WriteLn('Transfer failed: ' + StatusStr(AsyncStatus) + ' '+ Name2Transmit);

  Dispose(Protocol, Done);

  { RECEIVING }
  Delay(1000);
  { Normally the file transfers would start at this point }
  New(Protocol, Init(ComPort));
  if Protocol = nil then
    Abort('Failed to initialize protocol', AsyncStatus);

  {Set abort and status procedures}
  ComPort^.SetAbortFunc(KbdAbort);
  Protocol^.SetShowStatusProc(ProtocolStatus);

  {Set logging procedure}
  Protocol^.SetLogFileProc(ProtocolLogging);

  {Set accept file function}
  Protocol^.SetAcceptFileFunc(ProtocolAccept);

  {Receive files}
  Protocol^.ProtocolReceive;
  if AsyncStatus = ecOk then
    WriteLn('Receive complete OK')
  else
    WriteLn('Receive failed: ', StatusStr(AsyncStatus),(AsyncStatus));

  Dispose(Protocol, Done);

  Hangup;
  WriteLn('End of program');

  Dispose(ComPort, Done);

End.

{ It's really worked ???? I don't understand this -- O'ooouuu !}